// Fibonacci-Zahlen iterativ und rekursiv berechnen
// fib(0) = fib(1) = 1
// fib(n) = fib(n - 1) + fib(n - 2)

// Klasse zum Paket de.rekursion hinzufuegen
package de.rekursion;

public class Fibonacci {
	
	// naive rekursive Implementierung mit 2^n Aufrufen
	static public long fibRekursiv (long n) {
		if (n == 0 || n == 1)  // Terminierungsfall
			return 1;
		else
			return fibRekursiv(n - 1) + fibRekursiv(n - 2);
	}
	
	// verbesserte rekursive Implementierung mit linear vielen Aufrufen
	// uebergibt Ergebnis als Parameter, n zaehlt Schritte bis zum Ende
	static public long fibV (long n) {
		return fib1(n, 1, 0);
	}
	static public long fib1 (long n, long res, long p) {
		if (n == 0)
			return res;
		else
			return fib1(n - 1, res + p, res);
	}

	// iterative Loesung braucht nur eine lineare Anzahl an Additionen
	static public long fibIterativ (long n) {
		long result = 1, previous = 0;
		while (n > 0) {
			long pprev = previous;
			previous = result;
			result = result + pprev;
			--n;			
		}
		return result;
	}
}